\subsection{Propositions/Existensial.magda}
This module implements the truncated existensial quantifier, using the
HoTT library truncations.

\begin{Verbatim}[fontsize=\footnotesize]
module Propositions.Existensial where
open import lib.Base
open import lib.NType

open import lib.types.Truncation
open import lib.types.Sigma
open import lib.types.Pi
open import lib.types.TLevel
\end{Verbatim}

\subsubsection{Truncated Existensial
quantification}\label{truncated-existensial-quantification}

\begin{Verbatim}[fontsize=\footnotesize]
module _ {i j} (A : Type i) (B : A → Type j) where

  ∃ : Type (lmax i j)
  ∃ = Trunc (0 -1) (Σ A B)

  ∃-elim : ∀ {j} {P : ∃ → Type j}
         → (p : (x : ∃) → is-prop (P x)) (d : (a : Σ A B) → P [ a ])
         → Π ∃ P
  ∃-elim p = Trunc-elim p

  ∃-is-prop : is-prop ∃
  ∃-is-prop = Trunc-level
\end{Verbatim}
